---- vlakCooldowns
-- Written by Vlakarados @ Soulflayer EU (ru) /  @  
-- Hugely Based on KordaCooldown by Korda @ Tarren Mill EU / henrik_s @ wowinterface.com
-- Thanks to the wowinterface community that helped report bugs and suggestions, Danpiel and Kavrishka ;)

local addon, ns = ...  
local aspells = ns.aspells

-- Timer update throttle (in seconds). The lower, the more precise. Set it to a really low value and don't blame me for low fps
local throttle = 0.3

local timefilter
local tcfg
local fade = 0 -- 0 one color, 1 fades from green to red, 2 fades from red to green

local vtexture = "Interface\\AddOns\\vlakCooldowns\\bartexture"
local vfont = "Interface\\AddOns\\vlakCooldowns\\font.ttf"
local tfont = "Interface\\AddOns\\vlakCooldowns\\BANK.TTF"

local showmessages = 1

local growth = 0 -- 0 - centered, 1 - right or up, 2 - left or down
local valign = 1 -- 1 Horizontal, 0 Vertical

-- Defaults
local ypos = 405
local xpos = 506
local size = 40

local msgxpos = 505
local msgypos = 460
-- Gap between icons
local gap

local spells = {}
local bcr, bcg, bcb, gcr, gcg, gcb, gstart, gstop
local glowa = 0.5


local tempvar
local sfilter = {}
local filterspell = {}
local announceen = {}
local announceens = {}
local announcest = {}
local announcests = {}

----
local SetPoint = SetPoint
local GetTime = GetTime
local SetWidth = SetWidth
local SetValue, GetValue = SetValue, GetValue
local Show, Hide = Show, Hide
local pairs = pairs
local ldb
local vcd= "|cffFFFFFFvlak|r|cffC8FF00C|r|cffFFFFFFooldowns:|r"


-- Import your class abilities
local frames = { }
spells = aspells[select(2, UnitClass("player"))]

-- And Race
local race = aspells["RACE"]
for i = 1, table.getn(race[select(2, UnitRace("player"))]) do
	table.insert(spells, race[select(2, UnitRace("player"))][i])
end

-- And Pet, if you have one
local _, pcl = UnitClass("player")
local _, pra = UnitRace("player")
if pcl == "WARLOCK" or pcl == "HUNTER" or pcl == "MAGE" or pcl == "DEATHKNIGHT" then
	for i = 1, table.getn(aspells["PET"][select(2, UnitClass("player"))]) do
		table.insert(spells, aspells["PET"][select(2, UnitClass("player"))][i])
	end
end

-- Text on the screen when cooldown is ready
local msgf = CreateFrame("Frame", "vlakCooldownsMAnchor", UIParent)
msgf:SetHeight(96)
msgf:SetWidth(300)
msgf:SetPoint("BOTTOMLEFT", UIParent, "CENTER", msgxpos, msgxpos)

local msg = CreateFrame("MessageFrame", "vlakCooldownsMessage", msgf)
msg:SetHeight(32)
msg:SetInsertMode("TOP")
msg:SetFrameStrata("HIGH")
msg:SetAllPoints(msgf)
msg:SetTimeVisible(1)
msg:SetFadeDuration(1)
msg:SetFont(tfont, 12, "THINOUTLINE")

msgf.texture = msgf:CreateTexture("texture", "BACKGROUND")
msgf.texture:SetAllPoints(msgf)
msgf.texture:SetTexture(0,0.35,0, 0)

-- Main anchor
local anchor = CreateFrame("Frame", "vlakCooldownsAnchor", UIParent)
anchor:SetHeight(size)
anchor:SetWidth(size-4)
anchor.texture = anchor:CreateTexture("texture", "BACKGROUND")
anchor.texture:SetAllPoints(anchor)
anchor.texture:SetTexture(0,0.35,0, 0)
anchor:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", xpos, ypos) -- this will be reset in events, but..

danchor = CreateFrame("Frame", "vlakCooldownsDynamicAnchor", anchor) -- Dynamic anchor
danchor:SetHeight(size)
danchor:SetWidth(size-4)
danchor:SetPoint("BOTTOMLEFT", anchor, "BOTTOMLEFT", 0, 0)
danchor.texture = danchor:CreateTexture("texture", "BACKGROUND")
danchor.texture:SetAllPoints(danchor)
danchor.texture:SetTexture(1,0.35,0, 0) -- debug purpuse

-- Pulse anchor
local pulsef = CreateFrame("Frame", "vlakCooldownsPulseFrame", UIParent)
pulsef:SetHeight(150)
pulsef:SetWidth(150)
pulsef.texture = pulsef:CreateTexture("texture", "BACKGROUND")
pulsef.texture:SetAllPoints(pulsef)
pulsef.texture:SetTexture(0.5,0,0, 0)
pulsef:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", 300, 300)
local pulse = CreateFrame("Frame", "vlakCooldownsPulse", pulse)
pulse.texture = pulse:CreateTexture("texture", "HIGH")
pulse:SetAllPoints(pulsef)
pulse.texture:SetAllPoints(pulse)



local function ShowTooltip()
	GameTooltip:SetOwner(anchor, "ANCHOR_CURSOR")
	GameTooltip:AddLine(vcd)
    GameTooltip:AddDoubleLine("Drag: ", "Move cooldowns", 1, 1, 1, 1, 1, 1)
    GameTooltip:AddDoubleLine("Right click: ", "Set Size", 1, 1, 1, 1, 1, 1)
    --GameTooltip:AddDoubleLine("SetPortraitZoom", self.zoomLevel, 1, 1, 1, 1, 1, 1)    
	GameTooltip:Show()

end

function round(num, idp)
	return tonumber(string.format("%." .. (idp or 0) .. "f", num))
end

-- Announcer
local function announce(ability, chan)
	local msg = "CD READY: "
	if (chan=="p") then
		if (UnitInRaid("player")) then 
			SendChatMessage(msg..GetSpellLink(ability),"RAID")
		elseif (UnitInParty("player")) then
			SendChatMessage(msg..GetSpellLink(ability),"PARTY")
		end
	elseif (chan=="s") then
		SendChatMessage(msg..GetSpellLink(ability),"SAY")
	elseif (chan=="y") then
		SendChatMessage(msg..GetSpellLink(ability),"YELL")
	end
end


local thevalue
local function position()
	
	local shown = 0
	for k,v in pairs(frames) do
		local frame = frames[k]
		
		-- Check if the spell is in the spellbook. E.G. will of the forsaken will show as a black icon if you're not a Forsaken, when using a PvP trinket, as it has 45s shared cooldown.
		if (GetSpellInfo(GetSpellInfo(frame.spell)) or pcl == "PRIEST")then
			-- Check if ignored
			if (not tcfg.spells.ignore[k]) then
				local start, duration = GetSpellCooldown(frame.spell)
				if duration and duration > 1.5 and duration > timefilter then
					
					frame.start = start
					frame.duration = duration
					frame.bar:SetValue((frame.start - (GetTime() - frame.duration))/frame.duration)
					frame.tdur:SetText(math.floor(frame.start - (GetTime() - frame.duration)))
					
					-- fix for setting textures again when respecced. lol.
					-- Holy Word: ... Chakra state spell textures fix, sets all Holy Word: something textures to Holy Word: Chastise
					if ((pcl == "PRIEST") and (frame.spell == 88682 or frame.spell == 88684 or frame.spell == 88685)) then
						frame.texture:SetTexture(GetSpellTexture(GetSpellInfo(88625)))
					else
						frame.texture:SetTexture(GetSpellTexture(GetSpellInfo(frame.spell)))
					end
					
					
					if (valign == 1) then
						-- Horizontal
						frame:SetPoint("BOTTOMLEFT", danchor, "BOTTOMLEFT", shown * (size-4+gap), 0)
					else
						-- Vertical
						frame:SetPoint("BOTTOMLEFT", danchor, "BOTTOMLEFT", 0, shown * (size+gap))
					end
					shown = shown + 1
					frame:Show()
				end
			end
		end
	end
	
	
	
	if (shown>0) then
		thevalue = shown-1
	else
		thevalue = shown
	end
	
	if (valign == 1) then
		if (growth == 1) then
			danchor:SetPoint("BOTTOMLEFT", anchor, "BOTTOMLEFT", 0, 0)
		elseif (growth == 2) then
			danchor:SetPoint("BOTTOMLEFT", anchor, "BOTTOMLEFT", -(thevalue*(size-4+gap)), 0)
		else
			danchor:SetPoint("BOTTOMLEFT", anchor, "BOTTOMLEFT", -0.5*(thevalue*(size-4+gap)), 0)
		end
	else
		if (growth == 1) then
			danchor:SetPoint("BOTTOMLEFT", anchor, "BOTTOMLEFT", 0, 0)
		elseif (growth == 2) then
			danchor:SetPoint("BOTTOMLEFT", anchor, "BOTTOMLEFT", 0, -(thevalue*(size+gap)))
		else
			if (thevalue==1) then
				thevalue = 0
			end
			danchor:SetPoint("BOTTOMLEFT", anchor, "BOTTOMLEFT", 0, -0.5*(thevalue*(size+gap)))
		end	
	end
end

local function OnTooltipShow(self)
	self:AddLine(vcd)
	self:AddLine('|cffccccccClick:|r Toggle config mode')
end

-- Pulse function
local function ptimer(self, elapsed)
	self.lastupdate = self.lastupdate + elapsed
	self.ptime=self.ptime-elapsed
	if self.lastupdate > 0.05 then
		self:SetAlpha(self.ptime)
		
		if (self.ptime<=0) then
			self:Hide()
		end
		self.lastupdate = 0
	end
end

-- Update function
local function timer(self, elapsed)
	self.lastupdate = self.lastupdate + elapsed
	if self.lastupdate > throttle then
	
		-- Update bar value
		local p = (self.start - (GetTime() - self.duration))/self.duration
		self.bar:SetValue(p)
				
		-- Gradient bar		
		-- if fade is 1 make it gradient, else keep it as it was
		if fade == 1 then
			self.bar:GetStatusBarTexture():SetVertexColor(1-p, p, 0);
		elseif fade == 2 then	
			self.bar:GetStatusBarTexture():SetVertexColor(p, 1-p, 0);
		end
		
		-- Text update
		local n = self.start - (GetTime() - self.duration)
		self.tdur:SetText(math.floor(n))
				
		-- Glow
		if (n < gstop) then
			self.glow:Show()
		elseif (self.duration-n < gstart) then
			self.glow:Show()
		else
			self.glow:Hide()
		end
		
		-- Hide
		if (p <= 0) then
			msg:AddMessage(GetSpellInfo(self.spell), tcfg.msg.r, tcfg.msg.g, tcfg.msg.b)
			if tcfg.announce.enenabled and tcfg.announce.en[self.spell] then
				announce(self.spell, tcfg.announce.chan)
			end
			if (tcfg.pulse.enabled and tcfg.pulse.list[self.spell]) then
				pulse:Show()
				pulse:SetAlpha(0.7)
				pulse.texture:SetTexture(self.texture:GetTexture())
				pulse.lastupdate = 0
				pulse.ptime = 0.6
				pulse:SetScript("OnUpdate", ptimer)
			end
			self:Hide()
			position()
		end
		self.lastupdate = 0
	end
end

-- Frames
local function create(spell)

	-- Background
	local frame = CreateFrame("Frame", nil, UIParent)
	frame:SetHeight(size)
	frame:SetWidth(size-4)
	frame.texture = frame:CreateTexture("texture", "BACKGROUND")
	frame.texture:SetAllPoints(frame)
	frame.texture:SetTexture(0,0,0, 0.85)
	
	-- Cooldown Texture
	local texture = frame:CreateTexture()
	texture:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 2, 2)
	-- Holy Word: ... Chakra state spell textures fix, sets all Holy Word: something textures to Holy Word: Chastise
	if ((pcl == "PRIEST") and (spell == 88682 or spell == 88684 or spell == 88685)) then
		texture:SetTexture(GetSpellTexture(GetSpellInfo(88625)))
	else
		texture:SetTexture(GetSpellTexture(GetSpellInfo(spell)))
	end
	texture:SetTexCoord(0.08,0.92,0.08,0.92)
	texture:SetHeight(size-8)
	texture:SetWidth(size-8)
	
	-- Text Timer
	local tdur = frame:CreateFontString(nil, "OVERLAY")
    tdur:SetFont(vfont, 12, "OUTLINE")
    tdur:SetShadowColor(0,0,0,1)
	tdur:SetText("")
	tdur:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 2, 2)
	
	-- Status Bar Timer
	local bar = CreateFrame("StatusBar", nil, frame, "TextStatusBar")
	bar:SetStatusBarTexture(vtexture)
	bar:GetStatusBarTexture():SetVertexColor(bcr, bcg, bcb);
	bar:SetPoint("TOPLEFT", frame, "TOPLEFT", 2, -2)
	bar:SetHeight(3)
	bar:SetWidth(size-8)
	bar:SetMinMaxValues(0, 1)
	
	local glow = frame:CreateTexture(nil, "OVERLAY")
	glow:SetTexture("Interface\\SpellActivationOverlay\\IconAlert")
	glow:SetPoint("CENTER", frame)
	glow:SetHeight(frame:GetHeight()*1.5)
	glow:SetWidth(frame:GetWidth()*1.5)
	glow:SetTexCoord("0.00781250", "0.50781250", "0.53515625", "0.78515625")
	glow:SetVertexColor(gcr, gcg, gcb, glowa)
	glow:SetBlendMode("ADD")
	
	frame.bar = bar
	frame.tdur = tdur
	frame.texture = texture
	frame.lastupdate = 0
	frame.spell = spell
	frame.glow = glow
	
	frame:SetScript("OnUpdate", timer)
	frame:Hide()
	
	return frame
end
		

local menuFrame = CreateFrame("Frame", "ExampleMenuFrame", UIParent, "UIDropDownMenuTemplate")
local function mouseclick(self, button)

if button == "RightButton" then
	sfilter = {}
	filterspell = {}
	announcest = {}
	announcests = {}
	announceen = {}
	pulseen = {}
	pulseens = {}
	announceens = {}
	-- Populate ignore and announce menus
	for k, v in pairs(frames) do
		filterspell = {}
		announcests = {}
		announceens = {}
		pulseens = {}
		local spname = select(1, GetSpellInfo(k))
		filterspell.text = spname
		announcests.text = spname
		announceens.text = spname
		pulseens.text = spname
		
		filterspell.isNotRadio = true
		announcests.isNotRadio = true
		announceens.isNotRadio = true
		pulseens.isNotRadio = true
		
		filterspell.checked = not tcfg.spells.ignore[k]
		announcests.checked = tcfg.announce.st[k]
		announceens.checked = tcfg.announce.en[k]
		pulseens.checked = tcfg.pulse.list[k]
		
		filterspell.func = function() 
			tcfg.spells.ignore[k] = not tcfg.spells.ignore[k]
		end
		announcests.func = function() 
			tcfg.announce.st[k] = not tcfg.announce.st[k]
		end
		announceens.func = function() 
			tcfg.announce.en[k] = not tcfg.announce.en[k]
		end
		pulseens.func = function() 
			tcfg.pulse.list[k] = not tcfg.pulse.list[k]
		end
		
		table.insert(sfilter,filterspell)
		table.insert(announceen,announceens)
		table.insert(announcest,announcests)
		table.insert(pulseen,pulseens)
	end
	
	local menu = {
		{ text = vcd, isTitle = true,notCheckable = true},
		{ text = "", notCheckable = true},
		{ text = "Frame options", hasArrow = true, notCheckable = true, menuList = {
			{ text = "Align", hasArrow = true, notCheckable = true, menuList = {
					{ text = "Horizontal", checked = (valign==1), func = function() valign = 1; tcfg.frame.align = 1; position(); end },
					{ text = "Vertical", checked = (valign==0), func = function() valign = 0; tcfg.frame.align = 0; position(); end },
				} 
			},
			
			{ text = "Growth", hasArrow = true, notCheckable = true, menuList = {
					{ text = "Right or Up", checked = (growth==1), func = function() growth = 1; tcfg.frame.growth = 1; position(); end },
					{ text = "Left or Down", checked = (growth==2), func = function() growth = 2; tcfg.frame.growth = 2; position(); end },
					{ text = "Centered", checked = (growth==0), func = function() growth = 0; tcfg.frame.growth = 0; position(); end },
				} 
			},
			{ text = "Gap: |cffFFC800"..round(gap, 1), notCheckable = true, tooltipTitle = "Gap size", tooltipText = "Gap/space/interval between icons",
				func = function()
					StaticPopup_Show("VCSETGAP")				
				end 
			},
			{ text = "", notCheckable = true, disabled = true},	
			{ text = "Icon options", hasArrow = true, notCheckable = true,
				menuList = {
					{ text = "Set icon size: |cffFFC800"..round(size, 1), notCheckable = true, func = function()
						StaticPopup_Show("VCSETSIZE")				
					end },
					{ text = "", notCheckable = true, disabled = true},
					{ text = "Bar options", hasArrow = true, notCheckable = true,
						menuList = {
							{ text = "Set bar color", notCheckable = true, hasColorSwatch = true, 
								r = bcr, g = bcg, b = bcb,
								swatchFunc = function() 
										--bcr:SetVertexColor(select(1,ColorPickerFrame:GetColorRGB()), select(2,ColorPickerFrame:GetColorRGB()), select(3,ColorPickerFrame:GetColorRGB()) , 1)							
										tcfg.frame.bar.r = select(1,ColorPickerFrame:GetColorRGB())
										tcfg.frame.bar.g = select(2,ColorPickerFrame:GetColorRGB())
										tcfg.frame.bar.b = select(3,ColorPickerFrame:GetColorRGB())
										bcr = select(1,ColorPickerFrame:GetColorRGB())
										bcg = select(2,ColorPickerFrame:GetColorRGB())
										bcb = select(3,ColorPickerFrame:GetColorRGB())
										for k, v in pairs(frames) do
											v.bar:GetStatusBarTexture():SetVertexColor(select(1,ColorPickerFrame:GetColorRGB()), select(2,ColorPickerFrame:GetColorRGB()), select(3,ColorPickerFrame:GetColorRGB()) , 1)
										end
								end,
							},
						},
					},
					{ text = "Glow options", hasArrow = true, notCheckable = true,
						menuList = {
						{ text = "Set glow color", notCheckable = true, hasColorSwatch = true, 
							r = gcr, g = gcg, b = gcb,
							swatchFunc = function() 
									--bcr:SetVertexColor(select(1,ColorPickerFrame:GetColorRGB()), select(2,ColorPickerFrame:GetColorRGB()), select(3,ColorPickerFrame:GetColorRGB()) , 1)							
									tcfg.frame.glow.r = select(1,ColorPickerFrame:GetColorRGB())
									tcfg.frame.glow.g = select(2,ColorPickerFrame:GetColorRGB())
									tcfg.frame.glow.b = select(3,ColorPickerFrame:GetColorRGB())
									gcr = select(1,ColorPickerFrame:GetColorRGB())
									gcg = select(2,ColorPickerFrame:GetColorRGB())
									gcb = select(3,ColorPickerFrame:GetColorRGB())
									for k, v in pairs(frames) do
										v.glow:SetVertexColor(select(1,ColorPickerFrame:GetColorRGB()), select(2,ColorPickerFrame:GetColorRGB()), select(3,ColorPickerFrame:GetColorRGB()) , glowa)
									end
							end,
						},
						{ text = "Set glow start duration", notCheckable = true, tooltipTitle = "Start duration", tooltipText = "Time the glow shown at the start of cooldown", func = function() StaticPopup_Show("VCSETGSTART") end },
						{ text = "Set glow end duration", notCheckable = true, tooltipTitle = "End duration", tooltipText = "Time the glow shown before the end of cooldown", func = function() StaticPopup_Show("VCSETGSTOP") end },
					}
					},
				} 
			},
			},
		},
		{ text = "Message options", hasArrow = true, notCheckable = true, menuList = {
				{ text = "Set text size: |cffFFC800"..tcfg.msg.h, notCheckable = true, tooltipTitle = "Text height", tooltipText = "Text size of the on-screen cooldown ready messages", func = function() StaticPopup_Show("VCSETTEXTSIZE") end },
				{ text = "Set text color", notCheckable = true, hasColorSwatch = true, 
								r = tcfg.msg.r, g = tcfg.msg.g, b = tcfg.msg.b,
								swatchFunc = function() 
										--bcr:SetVertexColor(select(1,ColorPickerFrame:GetColorRGB()), select(2,ColorPickerFrame:GetColorRGB()), select(3,ColorPickerFrame:GetColorRGB()) , 1)							
										tcfg.msg.r = select(1,ColorPickerFrame:GetColorRGB())
										tcfg.msg.g = select(2,ColorPickerFrame:GetColorRGB())
										tcfg.msg.b = select(3,ColorPickerFrame:GetColorRGB())
								end,
							},
				{ text = "", notCheckable = true, disabled = true},
				{ text = "Test message", notCheckable = true, func = function()
						msg:AddMessage("Cool spell of pure awesomeness", tcfg.msg.r, tcfg.msg.g, tcfg.msg.b)
				end },
			},
		},
		{ text = "", notCheckable = true, disabled = true},
		{ text = "Spell filter", hasArrow = true, notCheckable = true,
				menuList = {
						{ text = "Set global ignore time: |cffFFC800"..round(timefilter, 1), notCheckable = true, tooltipTitle = "Ignore time", tooltipText = "When cooldowns start, if their time is less than this value, they will not be shown. Mainly for DK rune bug :(", func = function() StaticPopup_Show("VCSETTIMEFILTER") end },
						{ text = "Enable cooldown for: ", hasArrow = true, notCheckable = true, menuList = sfilter },	
				}
		},
		{ text = "Announce", hasArrow = true, notCheckable = true,
				menuList = {
						{ text = "Enabled", isNotRadio = true, checked = tcfg.announce.enenabled, tooltipTitle = "Announce enabled", tooltipText = "Global switch to allow any announces", func = function() 
							tcfg.announce.enenabled = not tcfg.announce.enenabled
						end },
						{ text = "Channel", hasArrow = true, notCheckable = true, tooltipTitle = "Announce channel", tooltipText = "Where to announce",
							menuList = {
								{ text = "Raid/Party", checked = (tcfg.announce.chan=="p"), func = function() tcfg.announce.chan = "p" end },
								{ text = "Say", checked = (tcfg.announce.chan=="s"), func = function() tcfg.announce.chan = "s" end },
								{ text = "Yell", checked = (tcfg.announce.chan=="y"), func = function() tcfg.announce.chan = "y" end },
							},
						},							
						{ text = "", notCheckable = true, disabled = true},	
						{ text = "Enabled spells:", hasArrow = true, notCheckable = true, menuList = announceen },	

				}
		},
		{ text = "Pulse", hasArrow = true, notCheckable = true,
				menuList = {
						{ text = "Enabled", isNotRadio = true, checked = tcfg.pulse.enabled, tooltipTitle = "Pulse enabled", tooltipText = "Global switch to allow any pulse notifications", func = function() 
							tcfg.pulse.enabled = not tcfg.pulse.enabled
						end },
						{ text = "Set pulse notification size: |cffFFC800"..round(tcfg.pulse.size, 1), notCheckable = true, func = function()
							StaticPopup_Show("VCSETPSIZE")				
						end },
						{ text = "", notCheckable = true, disabled = true},	
						{ text = "Enabled spells:", hasArrow = true, notCheckable = true, menuList = pulseen },	

				}
		},
		{ text = "", notCheckable = true, disabled = true},	

	}

		EasyMenu(menu, menuFrame, "cursor", 0 , 0, "MENU");
	end

	anchor:StopMovingOrSizing()
	msgf:StopMovingOrSizing()
	pulsef:StopMovingOrSizing()
end


StaticPopupDialogs["VCSETSIZE"] = {
	text = "Enter the size of the button (height)",
	button1 = "OK",
	button2 = "Cancel",
	timeout = 0,
	whileDead = true,
	hideOnEscape = true,
	hasEditBox = true,
	enterClicksFirstButton = true,
	exclusive = true,
	OnShow = function (self, data)
		self.editBox:SetText(size)
	end,
	OnAccept = function (self, data, data2)
			local text = self.editBox:GetText()
			if (tonumber(text)) then
				tcfg.frame.size = text
				size = text
				anchor:SetWidth(size-4)
				anchor:SetHeight(size)
				for k, v in pairs(frames) do
					v:SetHeight(size)
					v:SetWidth(size-4)
					v.texture:SetHeight(size-8)
					v.texture:SetWidth(size-8)
					v.bar:SetWidth(size-8)
				end
				position()
			else
				print(vcd, "Error: size is not a number")
			end
	end,
	EditBoxOnEscapePressed = function(frame) frame:GetParent():Hide() end,
}

StaticPopupDialogs["VCSETPSIZE"] = {
	text = "Enter the size of the pulse notification",
	button1 = "OK",
	button2 = "Cancel",
	timeout = 0,
	whileDead = true,
	hideOnEscape = true,
	hasEditBox = true,
	enterClicksFirstButton = true,
	exclusive = true,
	OnShow = function (self, data)
		self.editBox:SetText(tcfg.pulse.size)
	end,
	OnAccept = function (self, data, data2)
			local text = self.editBox:GetText()
			if (tonumber(text)) then
				tcfg.pulse.size = text
				tcfg.pulse.size = text
				pulsef:SetWidth(tcfg.pulse.size)
				pulsef:SetHeight(tcfg.pulse.size)
				pulse:SetAllPoints(pulsef)
				pulse.texture:SetAllPoints(pulse)
			else
				print(vcd, "Error: size is not a number")
			end
	end,
	EditBoxOnEscapePressed = function(frame) frame:GetParent():Hide() end,
}

StaticPopupDialogs["VCSETGAP"] = {
	text = "Enter the gap size between icons",
	button1 = "OK",
	button2 = "Cancel",
	timeout = 0,
	whileDead = true,
	hideOnEscape = true,
	hasEditBox = true,
	enterClicksFirstButton = true,
	exclusive = true,
	OnShow = function (self, data)
		self.editBox:SetText(gap)
	end,
	OnAccept = function (self, data, data2)
			local text = self.editBox:GetText()
			if (tonumber(text)) then
				tcfg.frame.gap = text
				gap = text
				position()
			else
				print(vcd, "Error: size is not a number")
			end
	end,
	EditBoxOnEscapePressed = function(frame) frame:GetParent():Hide() end,
}
StaticPopupDialogs["VCSETTEXTSIZE"] = {
	text = "Enter the height of text in messages",
	button1 = "OK",
	button2 = "Cancel",
	timeout = 0,
	whileDead = true,
	hideOnEscape = true,
	hasEditBox = true,
	enterClicksFirstButton = true,
	exclusive = true,
	OnShow = function (self, data)
		self.editBox:SetText(tcfg.msg.h)
	end,
	OnAccept = function (self, data, data2)
			local text = self.editBox:GetText()
			if (tonumber(text)) then
				text = floor(tonumber(text))
				tcfg.msg.h = text
				msg:SetFont(tfont, text, "THINOUTLINE")
			else
				print(vcd, "Error: size is not a number")
			end
	end,
	EditBoxOnEscapePressed = function(frame) frame:GetParent():Hide() end,
}
StaticPopupDialogs["VCSETGSTOP"] = {
	text = "Enter time in seconds when the glow must appear before the end of cooldown",
	button1 = "OK",
	button2 = "Cancel",
	timeout = 0,
	whileDead = true,
	hideOnEscape = true,
	hasEditBox = true,
	enterClicksFirstButton = true,
	exclusive = true,
	OnShow = function (self, data)
		self.editBox:SetText("")
	end,
	OnAccept = function (self, data, data2)
			local text = self.editBox:GetText()
			if (tonumber(text)) then
				tcfg.frame.glow.stop = tonumber(text)
				gstop = tonumber(text)
			else
				print(vcd, "Error: size is not a number")
			end
	end,
	EditBoxOnEscapePressed = function(frame) frame:GetParent():Hide() end,
}
StaticPopupDialogs["VCSETGSTART"] = {
	text = "Enter time in seconds for how long glow must be visible after the start of the cooldown",
	button1 = "OK",
	button2 = "Cancel",
	timeout = 0,
	whileDead = true,
	hideOnEscape = true,
	hasEditBox = true,
	enterClicksFirstButton = true,
	exclusive = true,
	OnShow = function (self, data)
		self.editBox:SetText("")
	end,
	OnAccept = function (self, data, data2)
			local text = self.editBox:GetText()
			if (tonumber(text)) then
				tcfg.frame.glow.start = tonumber(text)
				gstart = tonumber(text)
			else
				print(vcd, "Error: entered text is not a number")
			end
	end,
	EditBoxOnEscapePressed = function(frame) frame:GetParent():Hide() end,
}
StaticPopupDialogs["VCSETTIMEFILTER"] = {
	text = "Enter time in seconds. Cooldowns that START with less than this will not be shown",
	button1 = "OK",
	button2 = "Cancel",
	timeout = 0,
	whileDead = true,
	hideOnEscape = true,
	hasEditBox = true,
	enterClicksFirstButton = true,
	exclusive = true,
	OnShow = function (self, data)
		self.editBox:SetText("")
	end,
	OnAccept = function (self, data, data2)
			local text = self.editBox:GetText()
			if (tonumber(text)) then
				tcfg.spells.timefilter = tonumber(text)
				timefilter = tonumber(text)
			else
				print(vcd, "Error: entered text is not a number")
			end
	end,
	EditBoxOnEscapePressed = function(frame) frame:GetParent():Hide() end,
}

local function init()
		for k, v in pairs(spells) do
			if GetSpellInfo(v) then
				frames[v] = frames[v] or create(spells[k])
			end
		end
end


local function config()
	if(anchor:IsMovable()) then
		print(vcd, "Config mode disabled, positions saved")
		tcfg.frame.x = anchor:GetLeft()
		tcfg.frame.y = anchor:GetBottom()
		
		tcfg.pulse.x = pulsef:GetLeft()
		tcfg.pulse.y = pulsef:GetBottom()
		
		tcfg.msg.x = msgf:GetLeft()
		tcfg.msg.y = msgf:GetBottom()
		
		anchor.texture:SetTexture(0.1,0.1,0.1, 0)
		anchor:SetMovable(false)
		anchor:SetResizable(false)
		anchor:EnableMouse(false)	
		anchor:SetScript("OnEnter", function(s) end)
		anchor:SetScript("OnLeave", function(s) end)
		
		msgf.texture:SetTexture(0.1,0.1,0.1, 0)
		msgf:SetMovable(false)
		msgf:SetResizable(false)
		msgf:EnableMouse(false)
		
		pulsef:SetMovable(false)
		pulsef:SetResizable(false)
		pulsef:EnableMouse(false)
		pulsef.texture:SetTexture(0.5,0,0, 0)
	else
		print(vcd, "Config mode enabled, drag to reposition, right click for other options, /vc to save position")
		anchor:SetWidth(size-4)
		anchor.texture:SetTexture(0.1,0.4,0.7, 0.6)
		anchor:SetMovable(true)
		anchor:SetResizable(true)
		anchor:EnableMouse(true)
		--anchor:SetScript("OnEnter", function(s) ShowTooltip() end)
		--anchor:SetScript("OnLeave", function(s) GameTooltip:Hide() end)
		anchor:SetScript("OnMouseUp", mouseclick)
		anchor:SetScript("OnMouseDown", anchor.StartMoving)
		msgf.texture:SetTexture(0.5,0.5,0.3, 0.4)
		msgf:SetMovable(true)
		msgf:SetResizable(true)
		msgf:EnableMouse(true)	
		msgf:SetScript("OnMouseUp", mouseclick)
		msgf:SetScript("OnMouseDown", msgf.StartMoving)
		
		
		pulsef:SetMovable(true)
		pulsef:SetResizable(true)
		pulsef:EnableMouse(true)		
		pulsef:SetScript("OnMouseUp", mouseclick)
		pulsef:SetScript("OnMouseDown", pulsef.StartMoving)
		pulsef.texture:SetTexture(0.4,0,0, 0.5)
	end
end

-- Slash
SLASH_VLAKCD1, SLASH_VLAKCD2, SLASH_VLAKCD3 = '/vlakcd', '/vc', '/vlakcooldowns';
function SlashCmdList.VLAKCD(msg, editbox)		
	config()
end


-- Event Handling
local function event(self, event, arg1)
	if event == "SPELLS_CHANGED" or event == "PLAYER_ENTERING_WORLD" or event == "PLAYER_TALENT_UPDATE" then	
		init()
	end
	
	if event == "SPELL_UPDATE_COOLDOWN" then
		position()
	end
	
	if event == "ADDON_LOADED" and arg1 == "vlakCooldowns" then
			
		-- Saved Variables structure
		vlakcd = vlakcd or {}
		tcfg = vlakcd
		tcfg.frame = tcfg.frame or {}
		tcfg.frame.bar = tcfg.frame.bar or {}
		tcfg.frame.glow = tcfg.frame.glow or {}
		tcfg.msg = tcfg.msg or {}
		tcfg.spells = tcfg.spells or {}
		tcfg.announce = tcfg.announce or {} 
		tcfg.announce.en = tcfg.announce.en or {}
		tcfg.announce.st = tcfg.announce.st or {}
		tcfg.spells.ignore = tcfg.spells.ignore or {}
		tcfg.pulse = tcfg.pulse or {}
		tcfg.pulse.list = tcfg.pulse.list or {}
		
		-- Resurrection and defaults
		bcr = tcfg.frame.bar.r or 1
		bcg = tcfg.frame.bar.g or 0
		bcb = tcfg.frame.bar.b or 0
		
		gcr = tcfg.frame.glow.r or 1
		gcg = tcfg.frame.glow.g or 0
		gcb = tcfg.frame.glow.b or 0
		
		gstart = tcfg.frame.glow.start or 2
		gstop = tcfg.frame.glow.stop or 2
		
		timefilter = tcfg.spells.timefilter or 0
		
		tcfg.announce.stenabled = tcfg.announce.stenabled or false
		tcfg.announce.enenabled = tcfg.announce.enenabled or true
		
		tcfg.announce.chan = tcfg.announce.chan or "p"
		
		tcfg.msg.r = tcfg.msg.r or 0
		tcfg.msg.g = tcfg.msg.g or 1
		tcfg.msg.b = tcfg.msg.b or 0
		tcfg.msg.h = tcfg.msg.h or 16
		msg:SetFont(tfont, tcfg.msg.h, "THINOUTLINE")
		xpos = tcfg.frame.x or xpos
		ypos = tcfg.frame.y or ypos
		size = tcfg.frame.size or size
		gap = tcfg.frame.gap or 3
		valign = tcfg.frame.align or valign
		growth = tcfg.frame.growth or growth
		msgxpos = tcfg.msg.x or msgxpos
		msgypos = tcfg.msg.y or msgypos
		tcfg.pulse.x = tcfg.pulse.x or 500
		tcfg.pulse.y = tcfg.pulse.y or 300
		tcfg.pulse.enabled = tcfg.pulse.enabled or true
		tcfg.pulse.size = tcfg.pulse.size or 120
		
		pulsef:SetWidth(tcfg.pulse.size)
		pulsef:SetHeight(tcfg.pulse.size)
		pulse:SetAllPoints(pulsef)
		pulse.texture:SetAllPoints(pulse)
		anchor:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", xpos, ypos)
		msgf:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", msgxpos, msgxpos)
		pulsef:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", tcfg.pulse.x, tcfg.pulse.y)
	end
	
	if event == "PLAYER_LOGIN" then
		LDBo = LibStub('LibDataBroker-1.1'):NewDataObject('vlakCooldowns', {
			type = "launcher",
			icon = "Interface\\Icons\\Achievement_BG_grab_cap_flagunderXseconds",
			text = "",
			iconCoords = {0.08, 0.92, 0.08, 0.92},
			OnClick = config,
			OnTooltipShow = OnTooltipShow,
		})
	end
	
end




local vlakCooldowns = CreateFrame("Frame")
vlakCooldowns:RegisterEvent("PLAYER_ENTERING_WORLD")
vlakCooldowns:RegisterEvent("SPELL_UPDATE_COOLDOWN")
vlakCooldowns:RegisterEvent("SPELLS_CHANGED")
vlakCooldowns:RegisterEvent("PLAYER_TALENT_UPDATE")
vlakCooldowns:RegisterEvent("PLAYER_LOGIN")
vlakCooldowns:RegisterEvent("ADDON_LOADED")
vlakCooldowns:SetScript("OnEvent", event)